From 0e3f6ca2bda1aff43a2ef755a3df339d16500f09 Mon Sep 17 00:00:00 2001
From: David Carlos <ddavidcarlos1392@gmail.com>
Date: Mar 16 2018 02:30:29 +0000
Subject: [PATCH 8/17] Make Monitor code more readable and maintainable.


  - Add more useful tests to monitor.

---

diff --git a/kiskadee/monitor.py b/kiskadee/monitor.py
index 20afeef..12eaad1 100644
--- a/kiskadee/monitor.py
+++ b/kiskadee/monitor.py
@@ -1,6 +1,6 @@
 """Provide kiskadee monitoring capabilities.
 
-kiskadee monitors repositories checking for new package versions to be
+kiskadee monitors repositories checking for new project versions to be
 analyzed. This module provides such capabilities.
 """
 import threading
@@ -19,55 +19,57 @@ RUNNING = True
 class Monitor:
     """Provide kiskadee monitoring objects."""
 
-    def __init__(self, _session):
+    def __init__(self, _session, queues):
         """Return a non initialized Monitor."""
         self.session = _session
-        self.kiskadee_queue = None
+        self.kiskadee_queue = queues
 
-    def monitor(self, queues):
-        """Dequeue packages and check if they need to be analyzed.
-
-        The packages are dequeued from the `package_queue`. When a package
-        needs to be analyzed, this package is enqueued in the `analyses_queue`
-        so the runner component can trigger an analysis.  Each fetcher must
-        enqueue its packages in the `packages_queue`.
-        """
+    def start(self):
         kiskadee.logger.debug('kiskadee PID: {}'.format(os.getppid()))
         kiskadee.logger.debug('Starting monitor subprocess')
         kiskadee.logger.debug('monitor PID: {}'.format(os.getpid()))
 
         for fetcher in kiskadee.load_fetchers():
-            _start_fetcher(fetcher.Fetcher().watch)
+            thread = Monitor._start_fetcher(fetcher.Fetcher().watch)
 
         while RUNNING:
-            self.kiskadee_queue = queues
-            pkg = self.kiskadee_queue.dequeue_project()
-
-            if pkg:
-                self.send_to_runner(pkg)
-            time.sleep(2)
-            analyzed_project = self.kiskadee_queue.dequeue_result()
+            new_project = self.dequeue_from_fetchers()
+            self.send_project_to_runner(new_project)
+            analyzed_project = self.dequeue_analysis_from_runner()
             self.save_analyzed_project(analyzed_project)
 
-    def send_to_runner(self, data):
-        _name = data['fetcher'].split('.')[-1]
-        _fetcher = self._query(Fetcher).filter_by(name = _name).first()
-        _package = self._query(Package).filter_by(name = data['name']).first()
+    def dequeue_project_from_fetchers(self):
+        new_project = self.kiskadee_queue.dequeue_project()
+        return new_project if new_project else {}
 
-        if _fetcher:
-            data["fetcher_id"] = _fetcher.id
-            if not _package:
+    def dequeue_analysis_from_runner(self):
+        return self.kiskadee_queue.dequeue_result()
+
+    def send_project_to_runner(self, data):
+        if data:
+            fetcher, project = self.get_fetcher_and_project(data)
+            data["fetcher_id"] = fetcher.id if fetcher else ''
+            if not project:
                 kiskadee.logger.debug(
-                        "MONITOR: Sending package {}_{} "
+                        "MONITOR: Sending project {}_{} "
                         " for analysis".format(data['name'], data['version'])
                 )
                 self.kiskadee_queue.enqueue_analysis(data)
-            else:
-                new_version = data['version']
-                analysed_version = _package.versions[-1].number
-                fetcher = importlib.import_module(data['fetcher']).Fetcher()
-                if (fetcher.compare_versions(new_version, analysed_version)):
-                    self.kiskadee_queue.enqueue_analysis(data)
+            elif self.not_analyzed_project_version(project, data):
+                self.kiskadee_queue.enqueue_analysis(data)
+
+    def get_fetcher_and_project(self, data):
+        fetcher_name = data['fetcher'].split('.')[-1]
+        project_name = data['name']
+        fetcher = self._query(Fetcher).filter_by(name = fetcher_name).first()
+        project = self._query(Package).filter_by(name = project_name).first()
+        return fetcher, project
+
+    def not_analyzed_project_version(self, project, data):
+        project_version = data['version']
+        analysed_version = project.versions[-1].number
+        fetcher = importlib.import_module(data['fetcher']).Fetcher()
+        fetcher.compare_versions(project_version, analysed_version)
 
     def save_analyzed_project(self, data):
         if not data:
@@ -85,12 +87,13 @@ class Monitor:
         return self.session.query(arg)
 
 
-def _start_fetcher(module, joinable=False, timeout=None):
-    module_as_a_thread = threading.Thread(target=module)
-    module_as_a_thread.daemon = True
-    module_as_a_thread.start()
-    if joinable or timeout:
-        module_as_a_thread.join(timeout)
+    @staticmethod
+    def _start_fetcher(module, joinable=False, timeout=None):
+        module_as_a_thread = threading.Thread(target=module)
+        module_as_a_thread.daemon = True
+        module_as_a_thread.start()
+        if joinable or timeout:
+            module_as_a_thread.join(timeout)
 
 
 def daemon():
@@ -98,11 +101,10 @@ def daemon():
     # TODO: improve with start/stop system
     queues = kiskadee.queue.Queues()
     session = kiskadee.database.Database().session
-    monitor = Monitor(session)
+    monitor = Monitor(session, queues)
     runner = Runner()
     monitor_process = Process(
-            target=monitor.monitor,
-            args=(queues,)
+            target=monitor.start,
         )
     runner_process = Process(
             target=runner.runner,
diff --git a/kiskadee/tests/api/test_api.py b/kiskadee/tests/api/test_api.py
index e88fee5..7c8d021 100644
--- a/kiskadee/tests/api/test_api.py
+++ b/kiskadee/tests/api/test_api.py
@@ -50,10 +50,10 @@ class ApiTestCase(unittest.TestCase):
         Monitor(kiskadee.api.app.kiskadee_db_session())
         db_session = kiskadee.api.app.kiskadee_db_session()
         db_session.query(kiskadee.model.Package)\
-                  .filter_by().id = MagicMock(side_effect=side_effect)
+                  .filter_by().id = MagicMock()
 
         db_session.query(kiskadee.model.Version)\
-                  .filter_by().id = MagicMock(side_effect=side_effect)
+                  .filter_by().id = MagicMock()
         db_session.query().options()\
                   .filter().all = MagicMock(return_value=[analysis])
 
diff --git a/kiskadee/tests/integration/test_monitor.py b/kiskadee/tests/integration/test_monitor.py
index 6d64edf..eae9829 100644
--- a/kiskadee/tests/integration/test_monitor.py
+++ b/kiskadee/tests/integration/test_monitor.py
@@ -1,27 +1,36 @@
 import unittest
+from unittest.mock import MagicMock
 from sqlalchemy.orm import sessionmaker
 
 from kiskadee import model
 from kiskadee.monitor import Monitor
 from kiskadee.queue import Queues
-from kiskadee.model import Package, Analyzer, Report, Analysis
+from kiskadee.model import Package, Analyzer, Report, Analysis, Fetcher
 import kiskadee.queue
 import kiskadee.fetchers.debian
 import kiskadee.fetchers.anitya
+import kiskadee.fetchers.example
 from kiskadee.database import Database
 
 
 class MonitorTestCase(unittest.TestCase):
 
     def setUp(self):
-        self.engine = Database('db_test').engine
-        Session = sessionmaker(bind=self.engine)
-        self.session = Session()
-        self.monitor = Monitor(self.session)
-        self.queues = Queues()
-        model.Base.metadata.create_all(self.engine)
-        Analyzer.create_analyzers(self.session)
-        self.pkg1 = {
+        def mocked_models(klass):
+            class Package:
+                def all(self):
+                    [self.pkg1, self.pkg2, self.pkg3, self.pkg4]
+            klass()
+
+        self.example_fetcher = kiskadee.fetchers.example.Fetcher()
+        self.session = MagicMock()
+
+        queues = Queues()
+        self.monitor = Monitor(self.session, queues)
+
+        self.session.query = MagicMock(side_effect=mocked_models)
+
+        self.data1 = {
                 'name': 'curl',
                 'version': '7.52.1-5',
                 'fetcher': kiskadee.fetchers.debian.__name__,
@@ -31,34 +40,34 @@ class MonitorTestCase(unittest.TestCase):
                     'flawfinder': '><'},
                 'fetcher_id': 1}
 
-        self.pkg2 = {'name': 'urlscan',
-                     'version': '0.8.2',
-                     'fetcher': kiskadee.fetchers.debian.__name__,
-                     'meta': {'directory': 'pool/main/u/urlscan'},
-                     'results': {
-                            'cppcheck': '<>',
-                            'flawfinder': '><'},
-                     'fetcher_id': 1}
-
-        self.pkg3 = {'name': 'curl',
-                     'version': '7.52.2-5',
-                     'fetcher': kiskadee.fetchers.debian.__name__,
-                     'meta': {'directory': 'pool/main/c/curl'},
-                     'results': {
-                            'cppcheck': '<>',
-                            'flawfinder': '><'},
-                     'fetcher_id': 1}
-        self.pkg4 = {'name': 'urlanitya',
-                     'version': '0.11',
-                     'fetcher': kiskadee.fetchers.anitya.__name__,
-                     'meta': {
-                            'backend': 'gitHub',
-                            'homepage': 'https://github.com/GesielFreitas/Cros'
-                        },
-                     'results': {
-                            'cppcheck': '<>',
-                            'flawfinder': '><'},
-                     'fetcher_id': 1}
+        self.data2 = {'name': 'urlscan',
+                'version': '0.8.2',
+                'fetcher': kiskadee.fetchers.debian.__name__,
+                'meta': {'directory': 'pool/main/u/urlscan'},
+                'results': {
+                    'cppcheck': '<>',
+                    'flawfinder': '><'},
+                'fetcher_id': 1}
+
+        self.data3 = {'name': 'curl',
+                'version': '7.52.2-5',
+                'fetcher': kiskadee.fetchers.debian.__name__,
+                'meta': {'directory': 'pool/main/c/curl'},
+                'results': {
+                    'cppcheck': '<>',
+                    'flawfinder': '><'},
+                'fetcher_id': 1}
+        self.data4 = {'name': 'urlanitya',
+                'version': '0.11',
+                'fetcher': kiskadee.fetchers.anitya.__name__,
+                'meta': {
+                    'backend': 'gitHub',
+                    'homepage': 'https://github.com/GesielFreitas/Cros'
+                    },
+                'results': {
+                    'cppcheck': '<>',
+                    'flawfinder': '><'},
+                'fetcher_id': 1}
         self.analysis = {
                 'analyzer_id': 1,
                 'id': 1,
@@ -67,101 +76,50 @@ class MonitorTestCase(unittest.TestCase):
                         {'severity': 'warning'},
                         {'severity': 'style'},
                         {'severity': 'error'}
-                    ]
+                        ]
+                    }
                 }
-            }
-
-    def tearDown(self):
-        self.session.close()
-        model.Base.metadata.drop_all()
-
-    def test_return_fetcher_name(self):
-        fetcher = kiskadee.fetchers.debian.Fetcher()
-        self.assertEqual(fetcher.name, 'debian')
-
-    def test_save_package(self):
-        self.monitor._save_fetcher(kiskadee.fetchers.debian.Fetcher())
-        self.monitor.save_analyzed_project(self.pkg1)
-        self.monitor.save_analyzed_project(self.pkg2)
-        _pkgs = self.monitor.session.query(Package).all()
-        self.assertEqual(len(_pkgs), 2)
-        self.assertEqual(_pkgs[0].name, self.pkg1['name'])
-        self.assertEqual(_pkgs[1].name, self.pkg2['name'])
-
-    def test_save_reports(self):
-        _fetcher = model.Fetcher(
-                name='kiskadee-fetcher3', target='university'
-            )
-        _pkg = model.Package(
-                name='kiskadee-package', fetcher_id=1
-            )
-        _version = model.Version(
-                number='1.0-rc1', package_id=1
+
+    def test_dequeue_project_from_fetcher(self):
+        self.example_fetcher.watch()
+        monitored_project = self.monitor.dequeue_project_from_fetchers()
+        self.assertIn("version", monitored_project)
+        self.assertIn("name", monitored_project)
+        self.assertIn("fetcher", monitored_project)
+        self.assertEqual(monitored_project['version'], '0.1')
+
+    def test_run_fetchers_as_threads(self):
+        Monitor._start_fetcher(self.example_fetcher.watch)
+        Monitor._start_fetcher(self.example_fetcher.watch)
+        first_monitored_project = self.monitor.dequeue_project_from_fetchers()
+        second_monitored_project = self.monitor.dequeue_project_from_fetchers()
+        self.assertIn("version", first_monitored_project)
+        self.assertIn("version", second_monitored_project)
+        self.assertIn("name", first_monitored_project)
+        self.assertIn("name", second_monitored_project)
+        self.assertIn("fetcher", first_monitored_project)
+        self.assertIn("fetcher", second_monitored_project)
+
+    def test_send_project_to_runner(self):
+        fetcher = kiskadee.model.Fetcher(name='example')
+        project = kiskadee.model.Package(name='project1',
+                fetcher_id=fetcher.id)
+        self.monitor.get_fetcher_and_project = MagicMock(
+                return_value=[fetcher, {}]
+                )
+        self.monitor.not_analyzed_project_version = MagicMock(
+                return_value=True
                 )
-        _raw = {
-            'results': [
-                {'severity': 'warning'},
-                {'severity': 'style'},
-                {'severity': 'error'}
-            ]
-        }
-        _analysis = Analysis(
-                version_id=1,
-                analyzer_id=1,
-                id=1,
-                raw=_raw
-            )
-        self.session.add(_fetcher)
-        self.session.add(_pkg)
-        self.session.add(_version)
-        self.session.add(_analysis)
-        self.session.commit()
-        _dict_analysis = {
-                'results': _raw['results'],
-                'id': 1
-            }
-        self.monitor._save_reports(_dict_analysis, self.pkg1, 'cppcheck')
-        _report = self.monitor.session.query(Report).all()
-        self.assertEqual(len(_report), 1)
-
-    def test_save_version(self):
-        self.monitor._save_fetcher(kiskadee.fetchers.debian.Fetcher())
-        self.monitor.save_analyzed_project(self.pkg1)
-        _pkgs = self.monitor.session.query(Package).all()
-        _version = _pkgs[0].versions[0].number
-        self.assertEqual(_version, self.pkg1['version'])
-
-    def test_update_version(self):
-        self.monitor._save_fetcher(kiskadee.fetchers.debian.Fetcher())
-        self.queues.enqueue_project(self.pkg1)
-        self.queues.enqueue_project(self.pkg3)
-
-        _pkg = self.queues.dequeue_project()
-        self.monitor.save_analyzed_project(_pkg)
-
-        _pkg = self.queues.dequeue_project()
-        self.monitor.save_analyzed_project(_pkg)
-
-        _pkgs = self.monitor.session.query(Package).all()
-        self.assertEqual(len(_pkgs), 1)
-
-        _pkg_versions = self.monitor._query(Package).\
-            filter(Package.name == _pkg['name']).first().versions
-
-        _first_version = _pkg_versions[0].number
-        _current_version = _pkg_versions[-1].number
-        self.assertEqual(self.pkg1['version'], _first_version)
-        self.assertEqual(_pkg['version'], _current_version)
-
-    def test_save_package_anitya(self):
-        self.monitor._save_fetcher(kiskadee.fetchers.anitya.Fetcher())
-        self.queues.enqueue_project(self.pkg4)
-        _pkg = self.queues.dequeue_project()
-        self.monitor.save_analyzed_project(_pkg)
-        _pkgs = self.monitor.session.query(Package).all()
-        self.assertEqual(len(_pkgs), 1)
-        self.assertEqual(_pkgs[0].homepage, _pkg['meta']['homepage'])
-
-
-if __name__ == '__main__':
-    unittest.main()
+        self.monitor.send_project_to_runner(self.data1)
+        self.assertEqual(self.monitor.kiskadee_queue.dequeue_analysis(), self.data1)
+
+    @unittest.skip("will implement")
+    def test_receive_analysis_from_runner(self):
+        pass
+
+    @unittest.skip("will implement")
+    def test_save_analysed_runner_project(self):
+        pass
+
+        if __name__ == '__main__':
+            unittest.main()

